:: :: CLIENT

:: Inviting and locking:

In previous version of Warsow it was allready to enable automatic match locking
on match start. Now it's also possible to unlock team after match has begun or
invite players to join a locked team.

- /invite <player's number or name>
Invites specified player to your team.

- /lock
Locks your team, this can be used if team locking is enabled on the server and
the match is in progress. When locking is enabled teams will allready be locked
automatically on match start.

- /unlock
Unlocks your team, allowing everyone to join.

:: New graphical settings:

- cg_pickup_flash <0 or 1> - default: 1
Enables or disables the bright screen flash when picking up items.

- cg_damage_blend <0 or 1> - default: 1
Enable or disable flashing screen red when you get hit.

- cg_damage_kick <0 or 1> - default: 0
Toggles whether your screen will shake when you receive damage.

- cg_shadows <0, 1 or 2> - default: 1
Controls showing of model shadows. Value 0 disables them altogether. Value 1
enabled new pretty fast blob shadows. Using value 2 enables stencil shadows
(was r_stencilshadows 1 in last release).

- cg_showBloodTrail <0, 1 or 2> - default: 1
Toggles the display of blood effects when hit by a weapon or damaged by the
world. Using value 2 enables this effect, but keeps showing blood orginating
from yourself.

:: Weapon stats:

If you look at the scoreboard while playing, you will see a list of your weapon
stats. In addition to this, there is command for showing more accurate stats in
the console and a variable to hide stats from scoreboard.

- /stats
Shows your (or the player's you're chasing) weapon accuracy stats.

- cg_scoreboardStats <0 or 1> - default: 1
Toggles showing of scoreboard stats in the scoreboard.

:: HUD system:

For the new HUD commands, open up the updated HUDS.txt in the docs folder.
You can also have a look at all the hud sample provided in basewsw/huds.

- /help_hud
This command prints info about HUD scripting features.

:: Showing of player names and teammates armor and health:

There are now few nice ways to identify the players around you. You can even
see the health and armor of your teammates just by looking at them. These
features are on by default, but if you prefer not to see players' names you can
turn them of by using following settings:

- cg_showPlayerNames <0 or 1> - default: 1
Whether to shows everyone's, who is close enough, name next to their feet on
your screen.

- cg_showPointedPlayer <0 or 1> - default: 1
If this option is enabled, then the player's name who you're pointing at is
showed over his head. Also if this player happens to be your teammate you see
his health and armor under his name.

:: New font system:

Warsow now has new font system. You can specify what font to use some different
parts of, with the following variables:

- con_fontSystemSmall <font name> - default: "bitstream_10"
Sets the default small sized font to be used.

- con_fontSystemMedium <font name> - default: "bitstream_12"
Sets the default medium sized font to be used.

- con_fontSystemBig <font name> - default: "virtue_16"
Sets the default big sized font to be used.

- cg_scoreboardFont <font name> - default: "virtue_10"
Sets the font to be used for most of the text in scoreboard.

- cg_scoreboardWidthScale <positive number> - default: 1.0
Controls how much scoreboards width is made bigger or smaller.

:: Voice commands:

You now have an ability to communicate with your teammates and enemies using
voice commands. In the menu there is possibility to bind different messages to
different keys. The following two commands are used to generate these voice
messages:

- /vsay <voice token> <message>
Sends voice message specified by the token to everybody on the server. It will
be accompanied with chat message, that you can also specify. If you don't
specify any message a default one will be used. To get list of all the possible
voice tokens use this command without any arguments.

- /vsay_team <voice token> <message>
Sends voice message specified by the token to your teammates. It will be
accompanied with team chat message, that you can also specify, all the normal
say_team chat token can be used also in this message. If you don't specify any
message a default one will be used.

- cg_voiceChats <0 or 1> - default: 1
Whether to play voice messages at all.

- cg_volume_voicechats <0.0 - 2.0> - default: 1.0
Controls the relative volume of voice messages.

:: New player model, skin and color system:

You can now set model, skin and color for each team in the game (players, red,
blue, green, yellow). It does not depend on whether the team is your team or
enemy team, but rather you set the values for each invidual team. Later, you
can force your team to always be one of these teams and the enemy team to be
another one. These settings can be easily set from the UI, but here is a list
of variables anyway.

- cg_team[TEAM]model <model name> - default: ""
For every team there is a cvar named like this (for example cg_teamREDmodel).
If set to anything else than "" the model of all the players in this team will
be forced to the one specified.

- cg_team[TEAM]skin <skin name> - default: "default"
For every team there is a cvar named like this (for example cg_teamREDskin).
If set to anything else than "" the skin of all the players in this team will
be forced to the one specified.

- cg_team[TEAM]color <red green blue> - default: ""
For every team there is a cvar named like this (for example cg_teamREDcolor).
If set to anything else than "" the color of all the players in this team will
be forced to the one specified.

- cg_forceEnemyTeam <name> - default: ""
If this is set to something else than "", then all your enemies will always use
the model, skin and color of the team specified.

- cg_forceMyTeam <name> - default: ""
If this is set to something else than "", then all your teammates (and you
yourself in teamgames) will always use the model, skin and color of the team
specified.

:: BattlEye support:

The anti-cheat system BattlEye is now integrated in Warsow.
BattlEye.dll is the BE Client. Note: BattlEye doesn't have a linux client yet.
You can control the BE Client on the server browser screen, the corresponding
cvar is:

- cl_battleye <0 or 1> - default: 1
With BattlEye enabled, you can join any server. With BE disabled, you can only
join BE disabled and optional servers.

:: Timeout system:

You can now call a timeout when playing Warsow. This pauses game for some time,
allowing you to take that important phone call and after that continue playing
like nothing had happened. All servers might not allow timeouts, or only allow
certain amount per game. There are few commands for this purpose:

- /timeout
Starts a timeout. This pause will last three minutes unless timein is called
before that.

- /timein
Resumes game when in timeout. There will be five second countdown first.
Note that only the person or team who called the timeout can call timein.

- /callvote timeout
If the vote passes timeout begins. This can be used even if you or your team
doesn't have any timeouts left.

- /callvote timein
If the vote passes timein is called. This can be used even if you didn't call
the timeout.

- /callvote maxtimeouts <unlimited or a number>
Changes the number of timeouts a player, or a team in teambased gametypes, can
use in one game.

:: Automatic downloading:

It's now possible to automatically download missing maps from the web or
directly from the server. This feature is enabled by default, you don't need to
do anything. Two config variables allow you to control it:

- cl_downloads <0 or 1> - default: 1
Whether to allow automatic downloading at all.
Both from the web and directly from the server.

- cl_downloads_from_web <0 or 1> - default: 1
Enable or disable downloading from URLs provided by the server.

:: High resolution timer for Windows:

An enhanced timing system is available on win32 client. This code is activated
using a command line option (-hwtimer) and uses windows high resolution timers.
By default it is not activated as it may cause some lags on some computers. To
try it create a shortcut to warsow.exe and add -hwtimer to it or create a batch
file.

:: Lasergun:

It's now possible to choose if you want to draw the laserbeam client-side, or
server-side. A client-side laserbeam means that, when firing strong LG, you 
will see a straight beam, that will never go away from your crosshair. When you
choose for a server-side laserbeam, the beam will be drawn on your screen as the
server sees it, so it will be "laggy" when you move your mouse.

- cg_predictLaserBeam <0.0 to 1.0> - default: 1
Can be any value ranging from 0 to 1.
1 means client-side drawing.
0 means server-side drawing.

:: Misc new settings and commands:

- in_minmsecs <milliseconds> - default: 5
Defaults the minimum amount of time to wait before asking for new input data.

- cl_compresspackets <0 or 1> - default: 0
Whether to compress outgoing packets. Those packets are usually so small, that this variable shouldn't have any noticable effect.

- /drop <item>
This command was already present in last version. But now it includes some
handy shortcuts. You can use "weapon" as an argument, to drop your current
weapon, or "flag" to drop the flag. Other than that, you can use the name of
the item you want to drop, just like before.

:: :: SERVER

:: Timeout system:

As described above, clients can now call timeouts while in game. Server can
control how many timeouts per game are allowed with the following cvar:

- g_maxtimeouts <number>
This sets the number of timeouts each player, or a team in teambased gametypes,
can use per one game. If set to -1 unlimited number of timeouts is allowed.
Note that this cvar can be changed with callvote (to disable this callvote use
g_disable_vote_maxtimeouts 1).

:: Automatic downloading:

It's now possible to allow clients download missing maps from the server or
from URLs provided by the server. By default the server allows downloading
directly, but doesn't provide any URLs. Following variables can be used to
customize this behaviour:

- sv_uploads <0 or 1> - default: 1
Whether allow uploading at all. Both from the server or from URLs.

- sv_uploads_from_server <0 or 1> - default: 1
Enable or disable uploading directly from the server.

- sv_uploads_baseurl <URL> - default: "" (empty string)
Controls the URL sent to clients for webdownloading. This base value will have
a slash (/) and the filename (map_wdm1.pk3) appended to it, before it's send to
client. Use "" to disable sending of the URLs.

:: BattlEye support:

Like described above, there is now an anti-cheat system integrated in Warsow.
This system is based on master server and client that communicate through the
Warsow server. You can control BE support server side with the following cvar:

- sv_battleye <0, 1 or 2> - default: 1
Value 0 disables BattlEye support on the server. Values 1 and 2 enable it, the
difference is that 1 allows any player to join the server whereas 2 requires the
players to have BE enabled. Usage of this value is highly discouraged since
Linux version of Warsow client does not yet have support for BattlEye.
If BE is optional, you can use the "players" command to see who has BE enabled.

:: Challengers queue:

Duel gametype now allows for using challengers queue. This means that after
duel has been playing winner stays in and first player from challengers queue
replaces his opponent. Following cvar can be used to re-enable old behaviour.

- g_challengers <0 or 1> - default: 1
Whether to use challengers queue in duel and midair gametypes.

:: Console logging changes:

Variables for console logging have changes since last version. This allows
specifying a name for console log.

- logconsole <filename> - default: "wswconsole.log"
Sets the filename where to log console message. Use "" to disable logging.

- logconsole_append <0 or 1> - default: 1
Whether the append to the end of the old file if it exists, instead of
deleting it.

- logconsole_flush <0 or 1> - default: 0
Enabling this make Warsow flush console file after every printed line. This
takes much more resources, but ensures that you get last in the log if the game
crashes.
